import React from 'react';
import { CreateModalProps, CreateModalReturn } from './component';
export declare function useModalCreation<P, Q = void>(defaultProps?: Omit<CreateModalProps<P, Q>, 'children' | 'render'>): readonly [
    contextHolder: React.ReactElement,
    createModal: <T, R = void>(params: CreateModalProps<T, R>) => CreateModalReturn<T, R>
];
