import React, { isValidElement, Children, useEffect, useRef, useState } from "react";
import { Modal } from "antd";
export function TmpComp({ content , children =content , render , onOk , onCancel , onFailed , // onDeny,
// denyText,
// hideCancel = false,
// hideOk = false,
...rest }) {
    const formLikeRef = useRef();
    const [visible, setVisible] = useState(false);
    // const { /* direction, */ getPrefixCls } = React.useContext(ConfigContext);
    // const prefixCls = getPrefixCls('modal');
    // const rootPrefixCls = getPrefixCls();
    const [confirmLoading, setConfirmLoading] = useState(false);
    useEffect(()=>{
        // for animation
        setVisible(true);
    }, []);
    const handleOk = async ()=>{
        setConfirmLoading(true);
        try {
            var _formLikeRef_current, _formLikeRef_current1;
            const validateFields = ((_formLikeRef_current = formLikeRef.current) === null || _formLikeRef_current === void 0 ? void 0 : _formLikeRef_current.validateFieldsReturnFormatValue) || ((_formLikeRef_current1 = formLikeRef.current) === null || _formLikeRef_current1 === void 0 ? void 0 : _formLikeRef_current1.validateFields);
            const values = await (validateFields === null || validateFields === void 0 ? void 0 : validateFields());
            await (onOk === null || onOk === void 0 ? void 0 : onOk(values));
            setVisible(false);
        } catch (error) {
            // console.error(error);
            onFailed === null || onFailed === void 0 ? void 0 : onFailed(error);
        // throw error;
        } finally{
            setConfirmLoading(false);
        }
    };
    // const handleDeny = async () => {
    //   setConfirmLoading(true);
    //   try {
    //     const validateFields =
    //       formLikeRef.current?.validateFieldsReturnFormatValue || formLikeRef.current?.validateFields;
    //     const values = await validateFields?.();
    //     await onDeny?.(values);
    //     setVisible(false);
    //   } catch (error) {
    //     onFailed?.(error);
    //     console.error(error);
    //     // throw error;
    //   } finally {
    //     setConfirmLoading(false);
    //   }
    // };
    const handleCancel = (e)=>{
        setVisible(false);
        onCancel === null || onCancel === void 0 ? void 0 : onCancel(e);
    };
    const renderPropChildren = ()=>{
        if (render) return render(formLikeRef);
        let attached = false;
        return Children.map(children, (child)=>{
            if (!/*#__PURE__*/ isValidElement(child)) {
                return child;
            }
            if (attached) return child;
            const childProps = {
                ...child.props,
                ref: formLikeRef
            };
            attached = true;
            return /*#__PURE__*/ React.cloneElement(child, childProps);
        });
    };
    return(// <LocaleReceiver componentName="Modal">
    //   {(contextLocale) => (
    /*#__PURE__*/ React.createElement(Modal, {
        ...rest,
        // todo context value and locale
        // todo extra footer buttons
        confirmLoading: confirmLoading,
        onCancel: handleCancel,
        onOk: handleOk,
        // okText={contextLocale.okText || contextLocale.justOkText}
        // cancelText={contextLocale.cancelText}
        // footer={[
        //   hideCancel || (
        //     <Button key="cancel" onClick={handleCancel}>
        //       {rest?.cancelText || '取消'}
        //     </Button>
        //   ),
        //   onDeny && (
        //     <Button key="deny" type="primary" danger loading={confirmLoading} onClick={handleDeny}>
        //       {denyText || '驳回'}
        //     </Button>
        //   ),
        //   hideOk || (
        //     <Button key="ok" type="primary" loading={confirmLoading} onClick={handleOk}>
        //       {rest?.okText || '确定'}
        //     </Button>
        //   ),
        // ]}
        destroyOnClose: true,
        open: visible
    }, renderPropChildren()));
}
