export declare type CreateImagePreviewProps = {
    /**
     * @description image urls to preview
     * @default []
     */
    images?: string[];
    /**
     * @description initial index to preview
     * @default 0
     */
    current?: number;
    /**
     * @description callback on close
     */
    onClose?: () => void;
};
export default function createImagePreview({ onClose, ...rest }: CreateImagePreviewProps): void;
