import { CreateModalProps, CreateModalReturn } from './component';
/**
 * @description Create a one-off modal dialog dynamically without maintenance loading and visible.
 * @description.zh-CN 动态创建一次性的模态框，不需要维护 loading 和 visible。
 */
export default function createModal<T, R = void>(params: CreateModalProps<T, R>): CreateModalReturn<T, R>;
/**
 * @deprecated use `useModalCreation` instead
 */
export declare function createFunctionWithDefaultProps<T, R = void>(defaultParams: CreateModalProps<T, R>): (params: CreateModalProps<T, R>) => CreateModalReturn<T, R>;
export { useModalCreation } from './useModalCreation';
